<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<form [formGroup]="form" novalidate autocomplete="off">
  <mat-card id="electionPagePropertiesModelEdit" [class.read-only]="readOnly">
    <mat-card-header>
      <mat-card-title>{{ "parameters.election-page-properties.edit.models.details.title." + mode | translate }}
      </mat-card-title>
    </mat-card-header>

    <mat-card-content>


      <mat-form-field style="width: 100%">
        <input matInput name="modelName" formControlName="modelName"
               maxlength="255"
               placeholder="{{'parameters.election-page-properties.edit.models.form.fields.model-name' | translate  }}">
        <mat-error>
          <default-errors [fieldName]="'modelName'" [form]="form"></default-errors>
        </mat-error>
      </mat-form-field>


      <h2 class="section-title">
        {{ "parameters.election-page-properties.edit.models.form.sections.ballot-paper" | translate }}
      </h2>

      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.display-candidate-search-form' | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="displayCandidateSearchForm" color="primary"
                          formControlName="displayCandidateSearchForm"></mat-slide-toggle>
      </div>

      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.allow-change-of-electoral-list' | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="allowChangeOfElectoralList" color="primary"
                          formControlName="allowChangeOfElectoralList"></mat-slide-toggle>
      </div>


      <h2 class="section-title">
        {{ "parameters.election-page-properties.edit.models.form.sections.list-display" | translate }}
      </h2>

      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.display-empty-position' | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="displayEmptyPosition" color="primary"
                          formControlName="displayEmptyPosition"></mat-slide-toggle>
      </div>

      <h2 class="section-title">
        {{ "parameters.election-page-properties.edit.models.form.sections.candidate-display" | translate }}
      </h2>

      <label class="parent-label">
        {{'parameters.election-page-properties.edit.models.form.fields.display-candidate-position-on-ballot-paper.title'
        | translate }}
      </label>


      <div class="input-with-toggle input-with-toggle--padded">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.display-candidate-position-on-ballot-paper.compact-ballot-paper'
          | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="displayCandidatePositionOnACompactBallotPaper" color="primary"
                          formControlName="displayCandidatePositionOnACompactBallotPaper"></mat-slide-toggle>
      </div>

      <div class="input-with-toggle input-with-toggle--padded">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.display-candidate-position-on-ballot-paper.modified-ballot-paper'
          | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="displayCandidatePositionOnAModifiedBallotPaper" color="primary"
                          formControlName="displayCandidatePositionOnAModifiedBallotPaper"></mat-slide-toggle>
      </div>


      <div class="input-without-label">
        <div class="input">
          <mat-form-field style="width: 30em;">

            <mat-select name="candidateInformationDisplayModel" formControlName="candidateInformationDisplayModel"
                        placeholder="{{'parameters.election-page-properties.edit.models.form.fields.candidate-information-display-model' | translate  }}">
              <mat-option *ngFor="let possibleValue of possibleCandidateInformationDisplayModels"
                          [value]="possibleValue">
                {{ possibleValue }}
              </mat-option>
            </mat-select>
            <mat-error>
              <default-errors [fieldName]="'candidateInformationDisplayModel'" [form]="form"></default-errors>
            </mat-error>
          </mat-form-field>
        </div>

      </div>

      <h2 class="section-title">
        {{ "parameters.election-page-properties.edit.models.form.sections.summary-page" | translate }}
      </h2>


      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.display-suffrage-count' | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="displaySuffrageCount" color="primary"
                          formControlName="displaySuffrageCount"></mat-slide-toggle>
      </div>

      <h2 class="section-title">
        {{ "parameters.election-page-properties.edit.models.form.sections.verification-page" | translate }}
      </h2>


      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.display-list-verification-code' | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="displayListVerificationCode" color="primary"
                          formControlName="displayListVerificationCode"></mat-slide-toggle>

      </div>

      <div *ngIf="possibleColumnsForVerificationsCodes">
        <verification-code-edit [possibleColumns]="possibleColumnsForVerificationsCodes"
                                [(displayedColumns)]="displayedColumnsOnVerificationTable"
                                [(sortOrder)]="columnsOrderOnVerificationTable"
                                [readOnly]="readOnly">

        </verification-code-edit>
      </div>

      <h2 class="section-title">
        {{ "parameters.election-page-properties.edit.models.form.sections.rules" | translate }}
      </h2>

      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.allow-open-candidature' | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="allowOpenCandidature" color="primary"
                          formControlName="allowOpenCandidature"></mat-slide-toggle>
      </div>

      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.allow-multiple-mandates' | translate }}
        </label>

        <mat-slide-toggle #shouldPrint name="allowMultipleMandates" color="primary"
                          formControlName="allowMultipleMandates"></mat-slide-toggle>
      </div>

      <div class="input-with-toggle">
        <label>
          {{'parameters.election-page-properties.edit.models.form.fields.display-void-on-empty-ballot-paper' | translate
          }}
        </label>

        <mat-slide-toggle #shouldPrint name="displayVoidOnEmptyBallotPaper" color="primary"
                          formControlName="displayVoidOnEmptyBallotPaper"></mat-slide-toggle>
      </div>


    </mat-card-content>

    <mat-card-actions>
      <div fxLayout fxLayoutAlign="end">
        <ng-container *roles="['CREATE_ELECTION_PAGE_PROPERTIES_MODEL']">
          <button mat-raised-button *ngIf="!readOnly"
                  id="saveButton"
                  color="primary"
                  type="submit"
                  (click)="save()">{{'global.actions.save' | translate | uppercase}}
          </button>
        </ng-container>
      </div>
    </mat-card-actions>
  </mat-card>
</form>

